<template>
    <div ref="input" class="input" contenteditable="true"></div>
</template>
<script>
import isFirefox from './helpers/isFirefox';
import emoiToSrc from './helpers/emoiToSrc'
export default {
    name: 'registerForm',

    props: {
        init: {
            type: String,
            required: false,
            default: ''
        }
    },

    mounted() {
        this.$bus.$on('setEmoi', (emoi) => {

            this.$nextTick(() => {
                this.$refs.input.innerHTML += emoi;
                this.handleKeyDown();
            })

        })
        if (this.init === ':handwave:') {
            const img = new Image();
            img.setAttribute('height', 40);
            img.setAttribute('width', 'auto');
            img.src = '/emois/' + emoiToSrc[':handwave:'];
            this.$refs.input.appendChild(img)
            this.placeCaretAtEnd();
            this.$emit('content', this.$refs.input.innerHTML);
        };

        document.addEventListener('keyup', this.handleKeyDown, false);
        this.$bus.$on('clear-input', () => {
            if (this.$refs.input) {
                this.$refs.input.innerHTML = '';
            }

        });

        this.$refs.input.focus();
    },

    methods: {

        handleKeyDown(e) {
            const text = this.$refs.input.innerHTML;
            let img;
            let regEmoi;
            this.content = text.replace(/<img\s.*src="(.)[.s]*\/>/g, '$1');

            for (let emoi in emoiToSrc) {
                regEmoi = new RegExp(emoi + '$');

                if (text.match(regEmoi)) {
                    this.$refs.input.innerHTML = text.substring(0, text.length - 2);
                    img = new Image();
                    img.setAttribute('height', 20);
                    img.setAttribute('width', 'auto');
                    img.src = '/emois/' + emoiToSrc[emoi];
                    this.$refs.input.appendChild(img)
                    this.placeCaretAtEnd()
                    break;
                }
            }
            this.$emit('content', this.$refs.input.innerHTML)
        },

        placeCaretAtEnd() {
            this.$refs.input.focus();
            if (typeof window.getSelection !== 'undefined'
                && typeof document.createRange != 'undefined') {
                const range = document.createRange();
                range.selectNodeContents(this.$refs.input);
                range.collapse(false);
                const sel = window.getSelection();
                sel.removeAllRanges();
                sel.addRange(range);
            } else if (typeof document.body.createTextRange != 'undefined') {
                const textRange = document.body.createTextRange();
                textRange.moveToElementText(el);
                textRange.collapse(false);
                textRange.select();
            }
        },
    },
}
</script>

<style scoped lang="scss">
.input {
    z-index: 100;
    padding: 10px;
    height: 120px;
    width: 92% !important;
    overflow: auto;
    font-size: 20px;
    background: white;
    outline: 1px solid rgba($color: #afafaf, $alpha: 1.0);
    font-family: Roboto Mono;
    transform: translateX(32px) !important;
}
</style>
